SystemOrganization addCategory: #MultiQuoAndRem!

Object subclass: #MQARArrayWritter
	instanceVariableNames: 'collection position readLimit writeLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiQuoAndRem'!

!MQARArrayWritter commentStamp: 'hjo 7/2/2011 16:28' prior: 0!
I am stripped off version of WriteStream. MultiQuoAndRem can be computed faster by using me than by using OrderedCollection.!

!MQARArrayWritter classSide methodsFor: 'instance creation' stamp: 'hjo 7/2/2011 15:59'!
on: aCollection 
	"Answer an instance of me, streaming over the elements of aCollection."

	^self basicNew on: aCollection! !

!MQARArrayWritter classSide methodsFor: 'instance creation' stamp: 'hjo 7/2/2011 16:10'!
onArrayOfSize: anInteger

	^self on: (Array new: anInteger)! !

!MQARArrayWritter methodsFor: 'accessing' stamp: 'hjo 7/2/2011 16:26'!
array

	^collection! !

!MQARArrayWritter methodsFor: 'accessing' stamp: 'hjo 7/2/2011 15:57'!
nextPut: anObject 
	"Primitive. Insert the argument at the next position in the Stream
	represented by the receiver. Fail if the collection of this stream is not an
	Array or a String. Fail if the stream is positioned at its end, or if the
	position is out of bounds in the collection. Fail if the argument is not
	of the right type for the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 66>
	position >= writeLimit
		ifTrue: [^ self pastEndPut: anObject]
		ifFalse: 
			[position := position + 1.
			^collection at: position put: anObject]! !

!MQARArrayWritter methodsFor: 'private' stamp: 'hjo 7/2/2011 15:58'!
on: aCollection

	collection := aCollection.
	readLimit := aCollection size.
	position := 0.
	self reset.
	readLimit := 0.
	writeLimit := aCollection size! !

!MQARArrayWritter methodsFor: 'positioning' stamp: 'hjo 7/2/2011 15:58'!
reset
	"Set the receiver's position to the beginning of the sequence of objects."

	position := 0! !

Object subclass: #MultiQuoAndRem
	instanceVariableNames: 'dividers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiQuoAndRem'!

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
dividers

	^dividers
! !

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
dividers: anArray 

	^dividers := anArray! !

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
forClock

	^self new dividers: #(24 60 60); yourself! !

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
forYearMonthDayHourMinuteSecond

	^super new dividers: #(12 30 24 60 60); yourself! !

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 16:26'!
indexValue: aNumber

	|number answer|
	number := aNumber.
	answer := MQARArrayWritter onArrayOfSize: self dividers size.

	self dividers reverseDo: [:each| | qr |
		answer nextPut: (number \\ each)+1.
		number := number // each].

	^answer array reverse! !

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
unValue: anArray 

	|sum stream dStream|
	stream := anArray readStream.
	dStream := self dividers readStream.
	sum := stream next.
	[ stream atEnd ] whileFalse: [ sum := sum * dStream next + stream next ].
	^sum! !

!MultiQuoAndRem methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 16:26'!
value: aNumber

	|number answer|
	number := aNumber.
	answer := MQARArrayWritter onArrayOfSize: self dividers size + 1.

	self dividers reverseDo: [:each| | qr |
		answer nextPut: (number \\ each).
		number := number // each].

	answer nextPut: number.

	^answer array reverse
	! !

TestCase subclass: #MultiQuoAndRemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiQuoAndRem'!

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
testClock

	self assert:
		(MultiQuoAndRem new
			dividers: #(24 60 60);
			value: 650021 ) = #( 7 12 33 41 )! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
testIndexValue

	self assert:
		(MultiQuoAndRem new
			dividers: #(24 60 60);
			indexValue: 650021 ) = #( 13 34 42 )! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/25/2011 17:56'!
testUnValue

	|mq|
	mq := MultiQuoAndRem new.
	mq dividers: #(26 32).
	self assert: 128 equals: (mq unValue: #(0 4 0))! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/25/2011 17:56'!
testUnValue10

	|mq|
	mq := MultiQuoAndRem new.
	mq dividers: #(10 10 10).
	self assert: 1234 equals: (mq unValue: #(1 2 3 4))! !
